#!/bin/csh

if ("$1" == "") then
    if ( `uname -m ` == "k1om" ) then
        set dir="k1om"
    else
        set dir="intel64"
    endif
else if ("$1" != "intel64" && "$1" != "mic") then
    echo "ERROR: Unknown switch '$1'. Accepted values are 'intel64' and 'mic'"
    exit 1
else
    set dir="$1"
endif

setenv CLCK_ROOT /opt/ohpc/admin/clck/3.0.1

if !($?PATH) then
    setenv PATH /opt/ohpc/admin/clck/3.0.1/bin/${dir}
else
    setenv PATH /opt/ohpc/admin/clck/3.0.1/bin/${dir}:${PATH}
endif

if !($?LIBRARY_PATH) then
    setenv LIBRARY_PATH /opt/ohpc/admin/clck/3.0.1/lib/${dir}
else
    setenv LIBRARY_PATH /opt/ohpc/admin/clck/3.0.1/lib/${dir}:${LIBRARY_PATH}
endif

if !($?CPLUS_INCLUDE_PATH) then
    setenv CPLUS_INCLUDE_PATH /opt/ohpc/admin/clck/3.0.1/include
else
    setenv CPLUS_INCLUDE_PATH /opt/ohpc/admin/clck/3.0.1/include:${CPLUS_INCLUDE_PATH}
endif

if !($?INTEL_LICENSE_FILE) then
   setenv INTEL_LICENSE_FILE "/opt/ohpc/admin/clck/3.0.1/licenses:/opt/intel/licenses:${HOME}/intel/licenses:/Users/Shared/Library/Application Support/Intel/Licenses"
else
   setenv INTEL_LICENSE_FILE "${INTEL_LICENSE_FILE}:/opt/ohpc/admin/clck/3.0.1/licenses:/opt/intel/licenses:${HOME}/intel/licenses:/Users/Shared/Library/Application Support/Intel/Licenses"
endif

alias clusterchecker '/opt/ohpc/admin/clck/3.0.1/bin/clck.py'
alias clustercheck '/opt/ohpc/admin/clck/3.0.1/bin/clck.py'
alias cluster-check '/opt/ohpc/admin/clck/3.0.1/bin/clck.py'
