#!/bin/sh

if [ -z "$1" ]; then
    if [ `uname -m` == "k1om" ]
    then
        dir="mic"
    else
        dir="intel64"
    fi
else
    if [ "$1" != "intel64" -a "$1" != "mic" ]; then
        echo "ERROR: Unknown switch '$1'. Accepted values are: intel64, mic"
        return 1;
    fi
    dir="$1"
fi

CLCK_ROOT=/opt/ohpc/admin/clck/3.0.1
export CLCK_ROOT

if [ -z "${PATH}" ]
then
    PATH=/opt/ohpc/admin/clck/3.0.1/bin/${dir}
else
    PATH=/opt/ohpc/admin/clck/3.0.1/bin/${dir}:${PATH}
fi
export PATH

if [ -z "${LIBRARY_PATH}" ]
then
    LIBRARY_PATH=/opt/ohpc/admin/clck/3.0.1/lib/${dir}
else
    LIBRARY_PATH=/opt/ohpc/admin/clck/3.0.1/lib/${dir}:${LIBRARY_PATH}
fi
export LIBRARY_PATH

if [ -z "${CPLUS_INCLUDE_PATH}" ]
then
    CPLUS_INCLUDE_PATH=/opt/ohpc/admin/clck/3.0.1/include
else
    CPLUS_INCLUDE_PATH=/opt/ohpc/admin/clck/3.0.1/include:${CPLUS_INCLUDE_PATH}
fi
export CPLUS_INCLUDE_PATH

if [ -z "${INTEL_LICENSE_FILE}" ]
then
    INTEL_LICENSE_FILE="/opt/ohpc/admin/clck/3.0.1/licenses:/opt/intel/licenses:${HOME}/intel/licenses:/Users/Shared/Library/Application Support/Intel/Licenses"; export INTEL_LICENSE_FILE 
else
    INTEL_LICENSE_FILE="${INTEL_LICENSE_FILE}:/opt/ohpc/admin/clck/3.0.1/licenses:/opt/intel/licenses:${HOME}/intel/licenses:/Users/Shared/Library/Application Support/Intel/Licenses"; export INTEL_LICENSE_FILE
fi

alias clusterchecker='/opt/ohpc/admin/clck/3.0.1/bin/clck.py'
alias clustercheck='/opt/ohpc/admin/clck/3.0.1/bin/clck.py'
alias cluster-check='/opt/ohpc/admin/clck/3.0.1/bin/clck.py'
