/*
 * Copyright 2012-2015 Intel Corporation All Rights Reserved.
 *
 * The source code contained or described herein and all documents
 * related to the source code ("Material") are owned by Intel
 * Corporation or its suppliers or licensors. Title to the Material
 * remains with Intel Corporation or its suppliers and licensors. The
 * Material may contain trade secrets and proprietary and confidential
 * information of Intel Corporation and its suppliers and licensors,
 * and is protected by worldwide copyright and trade secret laws and
 * treaty provisions. No part of the Material may be used, copied,
 * reproduced, modified, published, uploaded, posted, transmitted,
 * distributed, or disclosed in any way without Intel's prior express
 * written permission.
 *
 * No license under any patent, copyright, trade secret or other
 * intellectual property right is granted to or conferred upon you by
 * disclosure or delivery of the Materials, either expressly, by
 * implication, inducement, estoppel or otherwise. Any license under
 * such intellectual property rights must be express and approved by
 * Intel in writing.
 *
 * Unless otherwise agreed by Intel in writing, you may not remove or
 * alter this notice or any other notice embedded in Materials by Intel
 * or Intel's suppliers or licensors in any way.
 */


#ifndef __CONNECTOR_EXTENSION_DOT_H__
#define __CONNECTOR_EXTENSION_DOT_H__

#include "cluster.h"
#include "transform.h"

/**
 * TranformData is intended to pprovided a parent class for the classes
 * that mirror clips rules modules.  One TranformData subclass is intended
 * to be a similar concept to a clck2 module.
 */

class Extension : public Transform {

    public:
        Extension(DbRead& db_read, void *clips_env);

        void set_cluster(const NsCluster::Cluster *cluster);

    protected:
        const NsCluster::Cluster *cluster;

    private:
        typedef Transform super;

};


typedef Extension *CreateExtension(DbRead& db_read, void *clips_env);

struct ExtensionData {
    void *libhandle;
    CreateExtension *create;
    Extension *extension;
};


#endif //#ifndef __CONNECTOR_TRANSFORM_DATA_DOT_H__
