; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defclass MICCHECK_HOST
  "This class represents miccheck test results for systems with
   Intel(R) Xeon Phi(TM) coprocessors."
  (is-a BASE_NODE TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (slot chk_num_dev_os (type SYMBOL) (allowed-symbols FAIL PASS NA))
  (slot chk_driver_loaded (type SYMBOL) (allowed-symbols FAIL PASS NA))
  (slot chk_num_dev_driver (type SYMBOL) (allowed-symbols FAIL PASS NA))
  (slot chk_mpssd_run (type SYMBOL) (allowed-symbols FAIL PASS NA))
  (slot stderr (type STRING)))

(defclass MICCHECK_DEVICE
  "This class represents the miccheck test results for Intel(R) Xeon
   Phi(TM) coprocessors installed in the host which the slot host
   points to."
  (is-a BASE_NODE TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (slot device_id (type STRING))
  (slot host (type INSTANCE) (allowed-classes MICCHECK_HOST))
  (slot chk_dev_online (type SYMBOL) (allowed-symbols FAIL PASS NA))
  (slot chk_daemon_available (type SYMBOL) (allowed-symbols FAIL PASS NA))
  (slot chk_flash_version (type SYMBOL) (allowed-symbols FAIL PASS NA)))
