; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defclass PROCESS
  "This class represents the data collected from the ps system
   utility.  The slot names roughly match the ps fields.  Instances of
   this class are created, and the data slots populated, by the
   connector component."
  (is-a BASE_NODE TIMESTAMP DATABASE)
  (role concrete)
  (pattern-match reactive)

  (slot cmd (type STRING) (default ?NONE))            ; command name
  (slot etime (type NUMBER) (default 0))              ; elapsed time
  (slot pcpu (type NUMBER) (default 0) (range 0 100)) ; percent cpu
  (slot pid (type INTEGER) (default ?NONE))           ; process id
  (slot pmem (type NUMBER) (default 0) (range 0 100)) ; percent memory
  (slot state (type STRING) (default ?NONE))          ; process state
  (slot uid (type INTEGER) (default ?NONE))           ; user id
  (slot username (type STRING) (default ?NONE)))      ; user
