; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defclass TOOL
  "This class represents any generic tool. Not all slots need to be
   populated, since all slots have default values. The rules can
   decide which slots are necessary depending on the type of tool

   Note: This slot is not derived from TIMESTAMP because there is no
   intention of doing time series analysis. Instead, the connector
   will always populate the slots with the most recent data"
  (is-a BASE_NODE DATABASE)
  (role concrete)
  (pattern-match reactive)

  ; This slot holds the name of the tool
  (slot toolname (type SYMBOL) (default UNKNOWN))

  ; This slot holds the tool's version, if applicable
  (slot version (type SYMBOL) (default UNKNOWN))

  ; This slot holds the stdout of a command run with the tool. It
  ; could be the output of running the command itself or it could be
  ; the output of running a script with the command etc
  (slot stdout (type STRING) (default ""))

  ; This slot holds the stderr of a command run with the tool. It
  ; could be the standard error seen when running the command itself
  ; or it could be the standard error when running a script with the
  ; command etc.
  (slot stderr (type STRING) (default "")))
