; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defclass IMPI
  "Base class to contain Intel(R) MPI Library runtime configuration
   settings.  Slot names directly correspond to Intel(R) MPI Library
   environment variable names, but in lower case.  This class should
   be inherited by all classes that have associated Intel(R) MPI
   Library settings."
  (is-a USER)
  (role abstract)

  (slot i_mpi_dapl_provider (type SYMBOL) (default ofa-v2-mlx4_0-1)
        (visibility public))
  (slot i_mpi_fabrics (type SYMBOL) (default shm:dapl)
        (allowed-values dapl ofa shm shm:dapl shm:ofa shm:tcp shm:tmi tcp tmi)
        (visibility public))
  (slot i_mpi_ofa_adapter_name (type SYMBOL) (default mlx4)
        (visibility public))
  (slot i_mpi_tcp_netmask (type SYMBOL) (default eth0)
        (visibility public))
  (slot i_mpi_tmi_provider (type SYMBOL) (default psm)
        (allowed-values mx psm)
        (visibility public)))

(defmessage-handler IMPI get-impi-setting-string ()
  "Return a string containing the most relevant Intel(R) MPI Library
   settings."
  (bind ?string (str-cat "I_MPI_FABRICS=" ?self:i_mpi_fabrics))
  (return ?string))
