; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defclass BASE_NODE
  "Fundamental base class for nodes.  This class should be inherited
   by all classes that need the base characteristics of a node, such
   as a unique node identifier."
  (is-a USER)
  (role abstract)

  (slot architecture (type SYMBOL) (allowed-symbols i686 k1om x86_64)
        (default x86_64) (visibility public))
  (slot node_id (type SYMBOL) (visibility public))
  (slot subcluster (type SYMBOL) (visibility public) (default default)))

(defclass NODE
  "The core class for nodes.  This class describes the hardware and
   software that comprises a node."
  (is-a BASE_NODE)
  (role concrete)
  (pattern-match reactive)

  (multislot role (type SYMBOL) (visibility public) (default compute)
             (allowed-symbols boot compute enhanced external head job_schedule
                              login network_address storage)))
