; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.


(deffunction tokenize (?delimiter ?string)
 "Given a delimiter and a string, return a multifield list containing
 the sequential tokens.  For example, (tokenize '.' '1.2.3')
 returns ('1', '2', '3')."
 ; create a multifield list to store the tokenized strings
 (bind ?tokens (create$))
 ; find the first occurrence of the token
 (bind ?index (str-index ?delimiter ?string))

 ; loop until all tokens have been processed
 (while (neq ?index FALSE)
  ; extract the string up to, but not including, the first instance
  ; of the token
  (bind ?value (sub-string 1 (- ?index 1) ?string))
  ; add the extracted value to the list of values
  (bind ?tokens (insert$ ?tokens (+ (length$ ?tokens) 1) ?value))
  ; shorten the string by removing the first value and token
  (bind ?string (sub-string (+ ?index 1) (str-length ?string) ?string))
  ; find the next occurrence of the token
  (bind ?index (str-index ?delimiter ?string)))

    ; save the value after the last token (if the token itself did not
            ; terminate the string)
    (if (neq (str-length ?string) 0) then
     (bind ?tokens (insert$ ?tokens (+ (length ?tokens) 1) ?string)))

(return ?tokens))
