; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(deffunction vercmp (?v1 ?v2)
 "Compare two versions, v1 and v2 and return -1 if v1 < v2, 0 if v1
 == v2, or 1 if v1 > v2.  This particular implementation assumes
 that all versions are composed purely of numbers (i.e., no letters,
     dashes, etc.) separated by periods."
 (bind ?t1 (tokenize "." ?v1))
 (bind ?t2 (tokenize "." ?v2))

 (bind ?len (max (length$ ?t1) (length$ ?t2)))

 (loop-for-count (?i 1 ?len) do
  (bind ?e1 (version-field ?i ?t1))
  (bind ?e2 (version-field ?i ?t2))
  (if (> ?e1 ?e2) then (return 1))
  (if (> ?e2 ?e1) then (return -1)))

 (return 0))
