; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defrule environment-data-missing
  "Check that environment data is available."
  (object (is-a CONFIG) (name [config]) (clck-checks $? environment $?))
  (object (is-a NODE) (node_id ?node)
          (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  (not (object (is-a ENVIRONMENT) (node_id ?node)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 90)
                 (state observed) (value TRUE)
                 (id "environment-data-missing")
                 (remedy "environment-data-missing-remedy")))

(defrule env-test
  "Check that an environment variable is uniform."
  (object (is-a CONFIG) (name [config]) (clck-mode certification | health)
          (clck-checks $? environment $?)
          (environment-blacklist $?blacklist))
  ?obj <- (object (is-a ENVIRONMENT)
                  (node_id ?n) (multiset_control TRUE)
                  (variable ?k) (value ?v) (true-value ?tv)
                  (require-uniformity TRUE))
  (test (< (send ?obj fraction (send ?obj uniformity-key) ?v) 0.9))
  (test (= (regex_match ?k $?blacklist) 0))
  (test (= (regex_match ?k (create$ "HOST" "HOSTNAME" "OLDPWD"
                                    "SSH_CLIENT" "SSH_CONNECTION"
                                    "SSH2_CLIENT" "^_$")) 0))
  =>
  (bind ?fraction (send ?obj fraction (send ?obj uniformity-key) ?v))
  (make-instance of BOOLEAN_SIGN (node_id ?n) (severity 40) (source ?obj)
                 (confidence (* 100 (- 1 ?fraction))) (state observed)
                 (value TRUE)
                 (id "environment-variable-not-uniform")
                 (args (create$ (* 100 ?fraction) ?k ?tv))))
