; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defrule kernel_param-data-missing
  "Check that kernel parameter data is available."
  (object (is-a CONFIG) (name [config]) (clck-checks $? kernel_param $?))
  (object (is-a NODE) (node_id ?node))
  (not (object (is-a KERNEL_PARAM) (node_id ?node)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 90)
                 (state observed) (value TRUE)
                 (id "kernel_param-data-missing")
                 (remedy "kernel_param-data-missing-remedy")))

(defrule kernel-param-not-uniform
  (object (name [config]) (clck-mode certification | health)
          (clck-checks $? kernel_param $?)
          (kernel-blacklist $?blacklist))
  ?obj <- (object (is-a KERNEL_PARAM)
                  (node_id ?n)
                  (param ?k) (value ?v)
                  (require-uniformity TRUE)
                  (multiset_control TRUE))
  (object (is-a NODE) (node_id ?n) (architecture ?arch))
  (test (< (send ?obj fraction (send ?obj uniformity-key) ?v) 0.9))
  (test (= (regex_match ?k $?blacklist) 0))
  =>
  (bind ?fraction (* 100 (send ?obj fraction (send ?obj uniformity-key) ?v)))
  (bind ?confidence (- 100 ?fraction))

  (make-instance of BOOLEAN_SIGN (node_id ?n) (severity 40) (source ?obj)
                 (confidence ?confidence) (state observed) (value TRUE)
                 (id "kernel-param-not-uniform")
                 (args (create$ ?fraction ?k ?v))))
