; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defrule mpi_internode-data-missing
  "Check that MPI inter node data is available."
  (object (is-a CONFIG) (name [config]) (clck-checks $? mpi_internode $?))
  (object (is-a NODE) (node_id ?node)
          (role $?role&:(member$ compute ?role)|:(member$ enhanced ?role)))
  (not (object (is-a MPI_INTERNODE) (node_id $?nodes&:(member$ ?node ?nodes))))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 90)
                 (state observed) (value TRUE)
                 (id "mpi_internode-data-missing")
                 (remedy "mpi_internode-data-missing-remedy")))

(defrule mpi-internode-broken
  "Check whether MPI intra node 'Hello World' is functional."
  (object (is-a CONFIG) (name [config]) (clck-mode certification | health)
          (clck-checks $? mpi_internode $?))
  ?obj <- (object (is-a MPI_INTERNODE) (node_id $?n)
                  (valid_nodes $?v))
  (test (not (and (subsetp ?n ?v) (subsetp ?v ?n))))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?n)
                 (confidence 90) (severity 90)
                 (state observed) (source ?obj) (value TRUE)
                 (id "mpi-internode-broken")
                 (args (send ?obj get-impi-setting-string))))
