; Copyright 2006-2015 Intel Corporation All Rights Reserved.
;
; The source code contained or described herein and all documents
; related to the source code ("Material") are owned by Intel
; Corporation or its suppliers or licensors. Title to the Material
; remains with Intel Corporation or its suppliers and licensors. The
; Material may contain trade secrets and proprietary and confidential
; information of Intel Corporation and its suppliers and licensors,
; and is protected by worldwide copyright and trade secret laws and
; treaty provisions. No part of the Material may be used, copied,
; reproduced, modified, published, uploaded, posted, transmitted,
; distributed, or disclosed in any way without Intel's prior express
; written permission.
;
; No license under any patent, copyright, trade secret or other
; intellectual property right is granted to or conferred upon you by
; disclosure or delivery of the Materials, either expressly, by
; implication, inducement, estoppel or otherwise. Any license under
; such intellectual property rights must be express and approved by
; Intel in writing.
;
; Unless otherwise agreed by Intel in writing, you may not remove or
; alter this notice or any other notice embedded in Materials by Intel
; or Intel's suppliers or licensors in any way.

(defrule offload_phi-data-missing
  "Check that Intel(R) Xeon Phi(TM) coprocessor offload data is available."
  (object (is-a CONFIG) (name [config]) (clck-checks $? offload_phi $?))
  (object (is-a NODE) (node_id ?node) (architecture x86_64))
  (object (is-a  XEON_PHI_PCI_DEVICE) (node_id ?node))
  (not (object (is-a OFFLOAD_PHI) (node_id ?node)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?node)
                 (confidence 90) (severity 90)
                 (state observed) (value TRUE)
                 (id "offload_phi-data-missing")
                 (remedy "offload_phi-data-missing-remedy")))

(defrule offload-failure
  "If Intel(R) Xeon Phi(TM) coprocessors are installed on the system,
   but one or more of the Phi cards fails offload. This will fire
   warning that one or more cards failed to offload correctly"
  (object (is-a CONFIG) (name [config]) (clck-mode compliance | health)
          (clck-checks $? offload_phi $?))
  ?obj <- (object (is-a OFFLOAD_PHI) (node_id ?hostname)
                  (num_offload_phi ?offload)
                  (num_lspci_phi ?lspci) (stderr ?err))
  (object (is-a NODE) (node_id ?hostname))
  (test (and (> ?lspci ?offload) (> ?lspci 0)))
  =>
  (make-instance of BOOLEAN_SIGN (node_id ?hostname)
                 (confidence 90) (severity 90) (source ?obj)
                 (state observed) (value TRUE) (id "offload-failure")
                 (args (create$ (- ?lspci ?offload) ?lspci))))
