#!/bin/bash

. $(dirname $0)/../../functions

ARCH=`uname -m`

case "${ARCH}" in
    "x86_64")
        mem_percent=20
        k=240

        memory_size 'KB'

        msq=$(( ($memory_size * 1024 * $mem_percent / 800) + ($k * $k) - $k ))
        mi=`echo $msq | awk '{ printf("%d", sqrt($1)) }'`

        if (( $mi % 128 > 64 )); then
            m=$(( $mi + 128 - $mi % 128 ))
        else
            m=$(( $mi - $mi % 128 ))
        fi

        n=$m

        export KMP_AFFINITY=granularity=fine,compact,1,0
        export LD_LIBRARY_PATH=$(dirname $0)/intel64
        $(dirname $0)/intel64/dgemm $m $n $k
        ;;

    "k1om")
        k=12380
        m=12380
        n=12380

        export KMP_AFFINITY=balanced
        export LD_LIBRARY_PATH=$(dirname $0)/mic
        $(dirname $0)/mic/dgemm $m $n $k
        ;;

    *)
        echo "Error executing dgemm, node arch unknown. (${ARCH})"
        exit 1
        ;;
esac
