#!/bin/bash

# This script actually runs IMB-MPI1 (pingpong)
# When mpirun is called with a nodefile spanning multiple architectures,
# it is not always aware of the correct location to call the binaries.

# As a work around, mpirun is made to invoke this script. This script identifies
# the platform it is running on and picks the appropriate pingpong binary.

# The first argument gives the script the location of Intel MPI.
# The remaining arguments are passed to IMB-MPI1 as is.

arch=`uname -m`
_arch_token="intel64"

case "$arch" in
    "k1om")
        _arch_token="mic"
        ;;
    "x86_64")
        _arch_token="intel64"
        ;;
    *)
        ;;
esac

BINARY="${1}/${_arch_token}/bin/IMB-MPI1"

shift

exec $BINARY $*
