#!/bin/bash

ARCH=`uname -m`

. $(dirname $0)/../../functions

mpivars

\which mpirun

RESULT=$?

case "${ARCH}" in

    "x86_64")
    BIN="$(dirname $0)/intel64/mpi_local.impi"
    ;;
    "k1om")

    BIN="$(dirname $0)/mic/mpi_local.impi"
    ;;
    *)
    exit 1
    ;;
esac

# Note: If the above command resulted in a value, we have a location
# for mpirun. So we can try and run mpi_local. If not, the STDOUT
# for this provider shall just remain empty.

# Configure MPI to timeout before CLCK does to give MPI a chance to cleanup
if [[ ! -z $CLCK_TIMEOUT && $CLCK_TIMEOUT -gt 5 ]]; then
    export I_MPI_JOB_TIMEOUT=$(( $CLCK_TIMEOUT - 5 ))
fi

if [ "$RESULT" == "0" ]
then
    # Note: The first line in STDOUT will be the path to mpirun.
    # Subsequently, there will be 40 asterixes. The connector
    # transform plugin should look for the first occurance of
    # 40 asterixes to locate the point beyond which the output
    # of mpirun is present in the STDOUT.
    echo "****************************************"
    mpirun -hosts $HOSTNAME -genv I_MPI_DEBUG 5 -n 4 $BIN
fi
