#!/bin/sh

function check_shell() {
    name=$1
    path=/bin/$1

    echo -n $1 " "

    # First, we test existence
    test -x $path
    echo -n $? " "

    # We create a temporary file in which to create a script
    TEMPF=$(mktemp)

    # Create the script
    echo echo HelloWorld > $TEMPF

    # Attempt to run the script with the shell
    RESULT=$($path $TEMPF 2>/dev/null)

    # Add it to STDOUT
    echo -n Output:$RESULT

    # Remove our temporary file
    rm $TEMPF

    # Wrap up this shell details with a newline
    echo
}

check_shell bash
check_shell tcsh
check_shell sh
check_shell ksh
check_shell csh
