#!/bin/bash

. $(dirname $0)/../../functions

memory_size 'MB'

# need at least 1500 MB
if [ $memory_size -lt 1500 ]; then
  echo "insufficent memory" >&2
  exit 1
fi

ARCH=`uname -m`

case "${ARCH}" in
"x86_64")
    compilervars
    LD_LIBRARY_PATH=$(dirname $0)/intel64 $(dirname $0)/intel64/stream
;;
"k1om")
    LD_LIBRARY_PATH=$(dirname $0)/mic $(dirname $0)/mic/stream
;;
*)
    echo "Error executing stream, node arch unknown. (${ARCH})" >&2
    exit 1
;;
esac
