#!/bin/bash

UNAME_SYSTEM=`(uname -s) 2>/dev/null`  || UNAME_SYSTEM=unknown
arch=`uname -m`

case "${UNAME_SYSTEM}" in
Darwin)
	stat -x /tmp
	;;
Linux|GNU|GNU/*)

        if [ "$arch" == "x86_64" ]; then
            stat /tmp
        elif [ "$arch" == "k1om" ]; then
            $(dirname $0)/mic/stat.coreutils /tmp
        fi
	;;
unknown)
	echo "Unrecognized system"
	exit 1
	;;
*)
	echo "Unable to detect system type"
	exit 2
	;;
esac
