#!/bin/sh

function uname_sh() {
    name=$1
    arg=$2

    out=`uname ${arg} 2> /dev/null`
    if [ $? == 0 ]; then
        echo "${name}: ${out}"
    else
        echo >&2 "${name}: unsupported"
    fi
}

uname_sh "kernel-name" "-s"
uname_sh "nodename" "-n"
uname_sh "kernel-release" "-r"
uname_sh "kernel-version" "-v"
uname_sh "machine" "-m"
uname_sh "processor" "-p"
uname_sh "hardware-platform" "-i"
uname_sh "operating-system" "-o"
uname_sh "all" "-a"
